
/'----------------------------------------------------------------------------*\
     This is a lib which reads 3d-studio binary files from version 3.0
     and higher
     (v1.05)
     author: Martin van Velsen
             ( and some great help by Gert van der Spoel )
     email:  vvelsen@ronix.ptf.hro.nl

     If you happen to come across some variables with strange names, then
     that will possible be Dutch names, sorry for that :)

\*----------------------------------------------------------------------------'/
#Ifndef __3DSBIN_C__
#define __3DSBIN_C__

#Include "3dsloader.bi"

/'----------------------------------------------------------------------------'/
Function ReadChar() As UByte
	Dim tmp As UByte
	Get #bin3ds,,tmp
	Return tmp
	'>------ if you want to add some code to create a progress bar, then
	'>------ I suggest you do it here. This is the only function which
	'>------ reads from disk
End Function
/'----------------------------------------------------------------------------'/
Function ReadInt () As UInteger
	Dim As UInteger temp = ReadChar()
	Return ( temp Or (ReadChar () Shl 8))
End Function
/'----------------------------------------------------------------------------'/
Function ReadLong () As ULong
	Dim As ULong temp1,temp2
	Dim As ULong temp3,temp4
	temp1=ReadInt()
	temp2=ReadInt()
	Return (temp3+(temp4*&h10000L))
End Function
/'----------------------------------------------------------------------------'/
Function ReadChunkPointer () As ULong
	Return (ReadLong())
End Function
/'----------------------------------------------------------------------------'/
Function GetChunkPointer() As ULong
	Dim As Integer posi=Seek(bin3ds)
	Dim As ULong tmp
	Get #bin3ds,posi-2,tmp
	Seek #bin3ds,posi
	Return tmp ' compensate for the already read Marker
End Function
/'----------------------------------------------------------------------------'/
Sub ChangeChunkPointer(temp_pointer As ULong)
	Seek #bin3ds,temp_pointer
End Sub
/'----------------------------------------------------------------------------'/
Function ReadName() As Integer
	Dim As UInteger teller=0
	Dim As UByte letter
	temp_name="Default name"
	letter=ReadChar ()
	If (letter=0) Then Return (-1) ' dummy object
	temp_name [teller]=letter
	teller+=1
	Do
		letter=ReadChar ()
		temp_name [teller]=letter
		teller+=1
	Loop While ((letter<>0) AndAlso (teller<12))
	temp_name [teller-1]=0
	#Ifdef __DEBUG__
	Print "     Found name : "+temp_name
	#EndIf
	Return (0)
End Function
/'----------------------------------------------------------------------------'/
Function ReadLongName() As Integer
	Dim As UInteger teller=0
	Dim As UByte letter
	temp_name="Default name"
	letter=ReadChar()
	If (letter=0) Then Return (-1) ' dummy object
	temp_name [teller]=letter
	teller+=1
	Do
		letter=ReadChar()
		temp_name [teller]=letter
		teller+=1
	Loop While (letter<>0)
	temp_name [teller-1]=0
	#Ifdef __DEBUG__
	Print "Found name : "+temp_name
	#EndIf
	Return (0)
End Function
/'----------------------------------------------------------------------------'/
Function ReadUnknownChunk (chunk_id As UInteger) As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	chunk_id=chunk_id
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadRGBColor () As ULong
	Dim As Single rgb_val(0 To 2)
	For i As Integer=0 To 2
		Get #bin3ds,,rgb_val(i),SizeOf (Single)
	Next
	#Ifdef __DEBUG__
	Print "     Found Color (RGB) def of: R: ";rgb_val(0);" G: ";rgb_val(1);" B: ";rgb_val(2)
	#EndIf
	Return (12L)
End Function
/'----------------------------------------------------------------------------'/
Function ReadTrueColor () As ULong
	Dim As UByte true_c_val(0 To 2)

	For i As Integer=0 To 2
		true_c_val(i)=ReadChar()
	Next
	#Ifdef __DEBUG__
	Print"     Found Color (24bit) def of: R: ";true_c_val(0);" G: ";true_c_val(1);" B: ";true_c_val(2)
	#EndIf
	Return (3L)
End Function
/'----------------------------------------------------------------------------'/
Function ReadBooleanChunk (bool As UByte Ptr) As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	*bool=ReadChar ()
	ChangeChunkPointer (current_pointer+temp_pointer) ' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadSpotChunk () As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As Single target(0 To 3)
	Dim As Single hotspot,falloff
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	Get #bin3ds,,target(0),SizeOf (Single)
	Get #bin3ds,,target(1),SizeOf (Single)
	Get #bin3ds,,target(2),SizeOf (Single)
	Get #bin3ds,,hotspot,SizeOf (Single)
	Get #bin3ds,,falloff,SizeOf (Single)
	#Ifdef __DEBUG__
	Print"      The target of the spot is at: X: ";target(0);" Y: ";target(1);" Z: ";target(2)
	Print"      The hotspot of this light is : ";hotspot
	Print"      The falloff of this light is : ";falloff
	#EndIf
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadLightChunk () As ULong
	Dim As UByte end_found=FALSE,bool
	Dim As UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L ' 2 id + 4 pointer
	Dim As Single light_coors(0 To 2)
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	Get #bin3ds,,light_coors(0),SizeOf (Single)
	Get #bin3ds,,light_coors(1),SizeOf (Single)
	Get #bin3ds,,light_coors(2),SizeOf (Single)
	#Ifdef __DEBUG__
	Print"     Found light at coordinates: X: ";light_coors(0);" Y: ";light_coors(1);" Z: ";light_coors(2)
	#EndIf
	While (end_found=FALSE)
		temp_int=ReadInt ()

		Select Case (temp_int)

			Case LIT_UNKNWN01 :
				#Ifdef __DEBUG__
				Print">>>>> Found Light unknown chunk id of ";Hex(LIT_UNKNWN01,4)
				#EndIf
				tellertje+=ReadUnknownChunk (LIT_UNKNWN01)
			Case LIT_OFF      :
				#Ifdef __DEBUG__
				Print">>>>> Light is (on/off) chunk: ",Hex(LIT_OFF,4)
				#EndIf
				tellertje+=ReadBooleanChunk(@bool)
				#Ifdef __DEBUG__
				If (bool=TRUE) Then
					Print"      Light is on"
				Else
					Print"      Light is off"
				EndIf
				#EndIf
			Case LIT_SPOT     :
				#Ifdef __DEBUG__
				Print">>>>> Light is SpotLight: ",Hex(TRI_VERTEXL,4)
				#EndIf
				tellertje+=ReadSpotChunk()
			Case COL_RGB      :
				#Ifdef __DEBUG__
				Print">>>>> Found Color def (RGB) chunk id of ",Hex(temp_int,4)
				#EndIf
				tellertje+=ReadRGBColor ()
			Case COL_TRU      :
				#Ifdef __DEBUG__
				Print">>>>> Found Color def (24bit) chunk id of ",Hex(temp_int,4)
				#EndIf
				tellertje+=ReadTrueColor ()
			Case Else           :
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer)Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadCameraChunk () As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As Single camera_eye(0 To 2)
	Dim As Single camera_focus( 0 To 2)
	Dim As Single rotation,lens
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	Get #bin3ds,,camera_eye(0),SizeOf (Single)
	Get #bin3ds,,camera_eye(1),SizeOf (Single)
	Get #bin3ds,,camera_eye(2),SizeOf (Single)
	#Ifdef __DEBUG__
	Print"     Found Camera viewpoint at coordinates: X: ";camera_eye(0);" Y: ";camera_eye(1);" Z: ";camera_eye(2)
	#EndIf
	Get #bin3ds,,camera_focus(0),SizeOf (Single)
	Get #bin3ds,,camera_focus(1),SizeOf (Single)
	Get #bin3ds,,camera_focus(2),SizeOf (Single)
	#Ifdef __DEBUG__
	Print"     Found Camera focus coors at coordinates: X: ";camera_focus(0);" Y: ";camera_focus(1);" Z: ";camera_focus(2)
	#EndIf
	Get #bin3ds,,rotation,SizeOf (Single)
	Get #bin3ds,,lens,SizeOf (Single)
	#Ifdef __DEBUG__
	Print"     Rotation of camera is:  ",rotation
	Print"     Lens in used camera is: ",lens;"mm"
	#EndIf
	If ((temp_pointer-38)>0) Then' this means more chunks are to follow
		#Ifdef __DEBUG__
		Print"     **** found extra cam chunks ****"
		#EndIf
		If (ReadInt ()=CAM_UNKNWN01)Then
			#Ifdef __DEBUG__
			Print"     **** Found cam 1 type ch ****"
			#EndIf
			ReadUnknownChunk (CAM_UNKNWN01)
		EndIf
		If (ReadInt ()=CAM_UNKNWN02)Then
			#Ifdef __DEBUG__
			Print"     **** Found cam 2 type ch ****"
			#EndIf
			ReadUnknownChunk (CAM_UNKNWN02)
		EndIf
	EndIf
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadVerticesChunk () As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As Single vertices(0 To 2) ' x,y,z
	Dim As UInteger numb_v
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	numb_vertices  =ReadInt ()
	#Ifdef __DEBUG__
	Print"      Found (";numb_vertices;") number of vertices"
	#EndIf
	For i As Integer=0 To numb_vertices-1
		Get #bin3ds,,vertices(0),SizeOf (Single)
		Get #bin3ds,,vertices(1),SizeOf (Single)
		Get #bin3ds,,vertices(2),SizeOf (Single)
		#Ifdef __DEBUG__
		Print"      Vertex nr ";i;": X: ";vertices(0);"  Y: ";vertices(1);"  Z: ";vertices(2)
		#EndIf
	Next
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadSmoothingChunk () As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong smoothing
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	For i As Integer=0 To numb_faces-1
		smoothing=ReadLong()
		smoothing=smoothing ' compiler warnig depressor *>:)
		#Ifdef __DEBUG__
		Print"      The smoothing group for face [";i;"] is ";smoothing
		#EndIf
	Next
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadFacesChunk () As ULong

	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As UInteger temp_diff
	Dim As UInteger faces(0 To 5) ' a,b,c,Diff (Diff= AB: BC: CA: )
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	numb_faces     =ReadInt ()
	#Ifdef __DEBUG__
	Print"      Found (";numb_faces;") number of faces"
	#EndIf
	For i As integer=0 To numb_faces-1
		faces (0)=ReadInt ()
		faces (1)=ReadInt ()
		faces (2)=ReadInt ()
		temp_diff=ReadInt () And &h000F
		faces (3)=(temp_diff And &h0004) Shr 2
		faces (4)=(temp_diff And &h0002) shr 1
		faces (5)=(temp_diff and &h0001)
		#Ifdef __DEBUG__
		print"      Face nr: ";i;", A: ";faces(0);" B: ";faces(1);" C: ";faces(2);" , AB: ";faces(3);" BC: ";faces(4);" CA: ";faces(5)

		#EndIf
	Next
	If (ReadInt ()=TRI_SMOOTH) Then
		ReadSmoothingChunk ()
		#Ifdef __DEBUG__
	Else
		Print"      No smoothing groups found, assuming autosmooth"
		#EndIf
	End If
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadTranslationChunk () As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	For j As integer=0 To 3
		For i As integer=0 To 2
			Get #bin3ds,,trans_mat(j,i),SizeOf (Single)
		Next
	Next
	trans_mat (0,3)=0
	trans_mat (1,3)=0
	trans_mat (2,3)=0
	trans_mat (3,3)=1
	#Ifdef __DEBUG__
	Print"     The translation matrix is:"
	For i As integer=0 To 3
		Print"      | ";trans_mat(i,0);" ";trans_mat(i,1);" ";trans_mat(i,2);" ";trans_mat(i,3);" |"
	next
	#EndIf
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End function
/'----------------------------------------------------------------------------'/
Function ReadObjChunk () As ULong
	dim as ubyte end_found=FALSE,bool=TRUE
	dim as uinteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L' 2 id + 4 pointer
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt ()
		Select Case (temp_int)
			Case TRI_VERTEXL :
				#Ifdef __DEBUG__
				print">>>>> Found Object vertices chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadVerticesChunk ()
			Case TRI_FACEL1  :
				#Ifdef __DEBUG__
				Print">>>>> Found Object faces (1) chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadFacesChunk ()
			Case TRI_FACEL2  :
				#Ifdef __DEBUG__
				Print">>>>> Found Object faces (2) chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadUnknownChunk (temp_int)
			Case TRI_LOCAL  :
				#Ifdef __DEBUG__
				Print">>>>> Found Object translation chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadTranslationChunk ()
			Case TRI_VISIBLE :
				#Ifdef __DEBUG__
				Print">>>>> Found Object vis/invis chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadBooleanChunk (@bool)
				#Ifdef __DEBUG__
				If (bool=TRUE) then
					Print"      Object is (visible)"
				Else
					Print"      Object is (not visible)"
				endif
				#EndIf
			Case else:
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer)Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadObjectChunk () As ULong
	Dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L ' 2 id + 4 pointer
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	If (ReadName ()=-1) Then
		#Ifdef __DEBUG__
		Print">>>>* Dummy Object found"
		#EndIf
	EndIf
	While (end_found=FALSE)
		temp_int=ReadInt ()
		Select Case (temp_int)
			Case OBJ_UNKNWN01: tellertje+=ReadUnknownChunk (OBJ_UNKNWN01)
			Case OBJ_UNKNWN02: tellertje+=ReadUnknownChunk (OBJ_UNKNWN02)
			Case OBJ_TRIMESH :
				#Ifdef __DEBUG__
				print">>>> Found Obj/Mesh chunk id of ";Hex(OBJ_TRIMESH,4)
				#EndIf
				tellertje+=ReadObjChunk ()
			Case OBJ_LIGHT   :
				#Ifdef __DEBUG__
				Print">>>> Found Light chunk id of ";Hex(OBJ_LIGHT,4)
				#EndIf
				tellertje+=ReadLightChunk ()
			Case OBJ_CAMERA  :
				#Ifdef __DEBUG__
				print">>>> Found Camera chunk id of ";Hex(OBJ_CAMERA,4)
				#EndIf
				tellertje+=ReadCameraChunk ()
			Case else
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer) Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadBackgrChunk () As ULong
	dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L ' 2 id + 4 pointer
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt ()
		Select Case (temp_int)
			Case COL_RGB :
				#Ifdef __DEBUG__
				print">> Found Color def (RGB) chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadRGBColor ()
			Case COL_TRU :
				#Ifdef __DEBUG__
				Print">> Found Color def (24bit) chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadTrueColor ()
			Case else:
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer)Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
function ReadAmbientChunk () As ULong
	dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L ' 2 id + 4 pointer
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt ()
		Select Case (temp_int)
			Case COL_RGB :
				#Ifdef __DEBUG__
				Print">>>> Found Color def (RGB) chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadRGBColor ()

			Case COL_TRU :
				#Ifdef __DEBUG__
				print">>>> Found Color def (24bit) chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadTrueColor ()
			Case else:
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer)Then end_found=TRUE
	wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End function
/'----------------------------------------------------------------------------'/
Function FindCameraChunk () As ULong
	Dim As Long temp_pointer=0L
	For i As integer=0 To 11
		ReadInt ()
	next
	temp_pointer=11L
	temp_pointer=ReadName ()
	#Ifdef __DEBUG__
	If (temp_pointer=-1) Then
		Print">>>>* No Camera name found"
	endif
	#EndIf
	Return (temp_pointer)
End function
/'----------------------------------------------------------------------------'/
Function ReadViewPortChunk () As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	dim as UInteger port,attribs
	views_read+=1
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	attribs=ReadInt ()
	If (attribs=3) Then
		#Ifdef __DEBUG__
		print"<Snap> active in viewport"
		#EndIf
	EndIf
	If (attribs=5) then
		#Ifdef __DEBUG__
		print"<Grid> active in viewport"
		#EndIf
	EndIf
	For i As Integer=0 To 5
		ReadInt () ' read 5 ints to get to the viewport
	Next
	port=ReadInt ()
	If ((port=&hFFFF) orelse (port=0)) Then
		FindCameraChunk ()
		port=CAMERA
	End If
	#Ifdef __DEBUG__
	print"Reading [";viewports(port);"] information with id: ";port
	#EndIf
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadViewChunk () As ULong
	dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt ()

		Select Case (temp_int)
			Case EDIT_VIEW_P1 :
				#Ifdef __DEBUG__
				Print">>>> Found Viewport1 chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadViewPortChunk ()
			Case EDIT_VIEW_P2 :
				#Ifdef __DEBUG__
				print">>>> Found Viewport2 (bogus) chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadUnknownChunk (EDIT_VIEW_P2)
			Case EDIT_VIEW_P3 :
				#Ifdef __DEBUG__
				Print">>>> Found Viewport chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadViewPortChunk ()
			Case Else        :
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer)Then end_found=TRUE
		If (views_read>3)Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadMatDefChunk () As ULong
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	If (ReadLongName ()=-1) Then
		#Ifdef __DEBUG__
		print">>>>* No Material name found"
		#EndIf
	EndIf
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadMaterialChunk () As ULong
	dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt ()
		Select Case (temp_int)
			Case MAT_NAME01  :
				#Ifdef __DEBUG__
				Print">>>> Found Material def chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadMatDefChunk ()
			Case Else:
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer)Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadEditChunk () As ULong
	dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt ()
		Select Case (temp_int)
			Case EDIT_UNKNW01:tellertje+=ReadUnknownChunk (EDIT_UNKNW01)
			Case EDIT_UNKNW02:tellertje+=ReadUnknownChunk (EDIT_UNKNW02)
			Case EDIT_UNKNW03:tellertje+=ReadUnknownChunk (EDIT_UNKNW03)
			Case EDIT_UNKNW04:tellertje+=ReadUnknownChunk (EDIT_UNKNW04)
			Case EDIT_UNKNW05:tellertje+=ReadUnknownChunk (EDIT_UNKNW05)
			Case EDIT_UNKNW06:tellertje+=ReadUnknownChunk (EDIT_UNKNW06)
			Case EDIT_UNKNW07:tellertje+=ReadUnknownChunk (EDIT_UNKNW07)
			Case EDIT_UNKNW08:tellertje+=ReadUnknownChunk (EDIT_UNKNW08)
			Case EDIT_UNKNW09:tellertje+=ReadUnknownChunk (EDIT_UNKNW09)
			Case EDIT_UNKNW10:tellertje+=ReadUnknownChunk (EDIT_UNKNW10)
			Case EDIT_UNKNW11:tellertje+=ReadUnknownChunk (EDIT_UNKNW11)
			Case EDIT_UNKNW12:tellertje+=ReadUnknownChunk (EDIT_UNKNW12)
			Case EDIT_UNKNW13:tellertje+=ReadUnknownChunk (EDIT_UNKNW13)
			Case EDIT_MATERIAL :
				#Ifdef __DEBUG__
				Print">>> Found Materials chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadMaterialChunk ()
			Case EDIT_VIEW1    :
				#Ifdef __DEBUG__
				Print">>> Found View main def chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadViewChunk ()
			Case EDIT_BACKGR   :
				#Ifdef __DEBUG__
				Print">>> Found Backgr chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadBackgrChunk ()
			Case EDIT_AMBIENT  :
				#Ifdef __DEBUG__
				Print">>> Found Ambient chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadAmbientChunk ()
			Case EDIT_OBJECT   :
				#Ifdef __DEBUG__
				Print">>> Found Object chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadObjectChunk ()

			Case Else:
		End Select

		tellertje+=2
		If (tellertje>=temp_pointer) Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End Function
/'----------------------------------------------------------------------------'/
Function ReadKeyfChunk () As ULong
	Dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt()
		Select Case (temp_int)
			Case KEYF_UNKNWN01 :tellertje+=ReadUnknownChunk (temp_int)
			Case KEYF_UNKNWN02 :tellertje+=ReadUnknownChunk (temp_int)
			Case KEYF_FRAMES   :
				#Ifdef __DEBUG__
				Print">>> Found Keyframer frames chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadUnknownChunk (temp_int)
			Case KEYF_OBJDES   :
				#Ifdef __DEBUG__
				Print">>> Found Keyframer object description chunk id of %&h\n";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadUnknownChunk (temp_int)
			Case EDIT_VIEW1    :
				#Ifdef __DEBUG__
				Print">>> Found View main def chunk id of ";Hex(temp_int,4)
				#EndIf
				tellertje+=ReadViewChunk ()
			Case Else:
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer)Then end_found=TRUE
	Wend
	ChangeChunkPointer (current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End function
/'----------------------------------------------------------------------------'/
Function ReadMainChunk () As ULong
	Dim as UByte end_found=FALSE
	dim as UInteger temp_int
	Dim As ULong current_pointer
	Dim As ULong temp_pointer
	Dim As ULong tellertje=6L
	current_pointer=GetChunkPointer ()
	temp_pointer   =ReadChunkPointer ()
	While (end_found=FALSE)
		temp_int=ReadInt()
		Select Case (temp_int)
			Case KEYF3DS :
				#Ifdef __DEBUG__
				print">> Found *Keyframer* chunk id of ",Hex(KEYF3DS,4)
				#EndIf
				tellertje+=ReadKeyfChunk ()
			Case EDIT3DS :
				#Ifdef __DEBUG__
				print">> Found *Editor* chunk id of ",Hex(EDIT3DS,4)
				#EndIf
				tellertje+=ReadEditChunk ()
			Case Else:
		End Select
		tellertje+=2
		If (tellertje>=temp_pointer) Then end_found=TRUE
	Wend
	ChangeChunkPointer(current_pointer+temp_pointer)
	' move to the new chunk position
	Return (temp_pointer)
End function
/'----------------------------------------------------------------------------'/
Function ReadPrimaryChunk () As Integer
	dim as ubyte version
	If (ReadInt() =MAIN3DS) Then
		#Ifdef __DEBUG__
		print"> Found Main chunk id of ";Hex(MAIN3DS,4)
		#EndIf
		'>---------- find version number
		seek #bin3ds,29L'28L
		version=ReadChar()
		If (version<3) Then
			#Ifdef __DEBUG__
			Print"Sorry this lib can only read 3ds files of version 3.0 and higher"
			print"The version of the file you want to read is: ";version
			#EndIf
			Return (1)
		EndIf
		seek #bin3ds,2
		current_chunk=ReadMainChunk()
	Else
		Return (1)
	End If
	Return (0)
End function
#EndIf
